<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995, 1996 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>C Preprocessor</title>
<link href="sx14d.html" rev=precedes>
<link href="sx14f.html" rel=precedes>
<link href="sx14.html" rev=subdocument>
</head>
<body>
<H2>C Preprocessor</H2>

<p>If you're careful,
it's possible
(and
can be
useful)
to use <TT>#include</TT> within a header file,
so that you end up with ``nested header files.''
</p><p>It's possible to use <TT>#define</TT>
to define ``function-like'' macros
that accept arguments;
the expansion of the macro can therefore depend on the
arguments it's ``invoked'' with.
</p><p>Two special preprocessing operators <TT>#</TT> and <TT>##</TT>
let you control the expansion of macro arguments
in fancier ways.
</p><p>The preprocessor directive <TT>#if</TT> lets you conditionally
include (or, with <TT>#else</TT>, conditionally not include)
a section of code depending on some arbitrary compile-time expression.
(<TT>#if</TT> can also do the same macro-definedness tests
as <TT>#ifdef</TT> and <TT>#ifndef</TT>,
because the expression can
use
a <TT>defined()</TT> operator.)
</p><p>Other preprocessing directives are
<TT>#elif</TT>, <TT>#error</TT>,
<TT>#line</TT>, and <TT>#pragma</TT>.
</p><p>There are a few predefined preprocessor macros,
some required by the C standard,
others perhaps defined by
particular compilation environments.
These are useful for conditional compilation
(<TT>#ifdef</TT>, <TT>#ifndef</TT>).
</p><hr>
<p>
Read sequentially:
<a href="sx14d.html" rev=precedes>prev</a>
<a href="sx14f.html" rel=precedes>next</a>
<a href="sx14.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995, 1996
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
